#ifndef _XBASCOUNT_H
#define _XBASCOUNT_H
#include <stdio.h>
#include "x_default.h"

#define xbc_file	 __FILE__

/* flags to control printing */
#define		XBC_PRT_INST	1	/* prints detailed counter basicops by basicops */
#define		XBC_PRT_SAT		2	/* prints detailed information for saturations	*/
#define		XBC_PRT_LINES	4	/* prints detailed information for saturations	*/

/* flags to control counting */
#define		XBC_COUNT_SAT_OFF	1
#define		XBC_COUNT_LINE_ON	2



typedef struct Xbas_count	Xbas_count ;

extern Xbas_count * curCount ;
/* allocation of a count struct with a name */
Xbas_count * XBC_Alloc(const char *name);

/* allow to retrieve at count struct by its name (can avoid to pass pointer between modules in different modules,
   so instrumentation is easier)
 */
Xbas_count * XBC_Get(const char *name);

/* 
   Ends the precedent frame, cumulates, and begins a new frame.
   If xbc == NULL , the action is done for  any counter
   else the action is done only for xbc 
   
*/
void XBC_EndFrame(Xbas_count *xbc);

/* if mode != 0 , no detailed count (line by line) for saturation, faster execution.
   defaut : mode = 0 */
void XBC_SetMode(Xbas_count *xbc,int mode);

/* change current counter struct for basic-ops
   If no current counter struct is set , basic-ops counts are added to "garbage" counter struct with name "" */
void XBC_SetCurrent(Xbas_count *xbc ) ;

/* RAZ of a counter struct for basic-ops */
void XBC_Clear(Xbas_count *xbc) ;

/* add xbcInc to xbcSum
   if xbcInc == NULL all the counter struct are added to xbcSum */
void XBC_Add(Xbas_count *xbcSum,Xbas_count *xbcInc) ;

/* print count struct. FLags : XBC_PRT_INST : detailed results basicop by basicop. XBC_PRT_SAT : detailed results for saturations */
void XBC_Print(Xbas_count *xbc,int flgsPrt,FILE *stdPrnt);

#endif












