/*=======================================================================================================*/
/*      Distributed Speech Recognition                                                                   */
/*      ETSI ES 202 050 Advanced Front-End Feature Extraction Algorithm & Compression Algorithm &        */
/*      ETSI ES 202 212 Extended Advanced Front-End Feature Extraction Algorithm & Compression Algorithm */  
/*      Bit exact C-language software implementation using ETSI basic operations library                 */
/*      3GPP TS 26.243 v 6.1.0 November 2004                                                                  */
/*      ANSI C code for the Fixed-Point Distributed Speech Recognition Extended Advanced Front-end       */
/*=======================================================================================================*/


/*
***********************************************************************
*
*   FUNCTION NAME:
*
*      This file contains the following functions:
*
*      1) sqrt_l_fix
*
*      2) fnLog2
*
*   PURPOSE:
*
*      Header file
*
**********************************************************************
*/

#ifndef _FIX_MATHLIB_H
#define _FIX_MATHLIB_H

#include "ParmType.h"
Shortword sqrt_l_fix(Longword L_arg);
Shortword fnLog2(Longword L_arg);

#endif	/* _FIX_MATHLIB_H */

