/*---------------------------------------------------------------------------
*
* Extended Advanced Front End for Distributed Speech Recognition (DSR)
* and Back End Speech Reconstruction
*
* FILE NAME: ParmType.h
* PURPOSE:   Definition of types
*
* This software has been released to the members of the Aurora Project
* to be used in the validation and verification of the proposed ETSI
* Advanced DSR Front End.
*
*---------------------------------------------------------------------------*/

#ifndef _PARMTYPE_H
#define _PARMTYPE_H

/*-----------------
 * File Inclusions
 *-----------------*/
#include "x_default.h"

/*---------------------
 * Definition of Types 
 *---------------------*/
#define BOOLEAN int
#define FALSE 0
#if !defined(TRUE)
#define TRUE (!FALSE)
#endif

#define FILE_TYPE   X_INT16

typedef X_INT16 Shortword;
typedef X_INT32 Longword;

typedef struct
{
  Shortword swMantissa;
  X_INT16   iShift;
} NormSw;

typedef struct
{
  Longword lwMantissa;
  X_INT16  iShift;
} NormLw;


/*-------------------------
 * Definition of Constants
 *-------------------------*/

#ifndef FRAME_LEN
#define FRAME_LEN               200
#endif
#ifndef FRAME_SHIFT
#define FRAME_SHIFT             80
#endif
#define HISTORY_LEN             100
#define DOWN_SAMP_FACTOR        4


#endif
