/*=======================================================================================================*/
/*      Distributed Speech Recognition                                                                   */
/*      ETSI ES 202 050 Advanced Front-End Feature Extraction Algorithm & Compression Algorithm &        */
/*      ETSI ES 202 212 Extended Advanced Front-End Feature Extraction Algorithm & Compression Algorithm */  
/*      Bit exact C-language software implementation using ETSI basic operations library                 */
/*      3GPP TS 26.243 v 6.1.0 November 2004                                                                  */
/*      ANSI C code for the Fixed-Point Distributed Speech Recognition Extended Advanced Front-end       */
/*=======================================================================================================*/
/*-------------------------------------------------------------------------------
 *
 * FILE NAME: 
 *
 *   coder.h
 *
 * PURPOSE:   
 *
 *   Header for DSR compression coder.
 *
 *-------------------------------------------------------------------------------*/

#include "typedef.h"


int htk_header_error( HTK_Header *given );
#ifdef XAFE
void quantise_and_print( HTK_DataFrame *first, HTK_DataFrame *second, 
                         float *pitch1, float *pitch2, unsigned char *class1, unsigned char *class2, 
                         int numFrames);
#else
void quantise_and_print( HTK_DataFrame *first, HTK_DataFrame *second, 
                         int numFrames);
#endif
Word16 best_centroid(Word16 a, Word16 b, const Word16 table[][2], int NumCentroids, Flag weighting);
void read_htk_header( HTK_Header *header );
int read_htk_coefs( int *VAD_data, HTK_DataFrame *given );
#ifdef XAFE
void print_txt_coefs( UWord8 *index_array, UWord8 pitch_index, UWord8 class_index );
#else
void print_txt_coefs( UWord8 *index_array );
#endif
void get_best_dataframe(UWord8 *index_array, HTK_DataFrame *given);
void print_txt_header( void );
void print_bit_header( UWord16 mframeCounter );
void process_params( int argc, char *argv[] );
void print_usage( void );
#ifdef XAFE
void quant_pitch_abs(Word32 lwPeriod, Word32 *plwQuantPeriod, UWord8 *pcQPIndex);
void quant_pitch_diff(Word32 lwPeriod, Word32 *plwQPHistory,Word16 *piReliableFlag, 
                      Word32 *plwQuantPeriod, UWord8 *pcQPIndex);
void get_class_bit(UWord8 class, UWord8 *class_index);
#endif
void Swap16 ( Word16 *Short ) ;
void Swap32 ( Word32 *Long ) ;
